import matplotlib as mpl
import matplotlib.pyplot as plt
import numpy as np
import csv
import os
import sys

p2 = r"C:\Users\Johannes\Documents\Masteroppgave\Calibration\Comparison"

x = ['5d', '10d', '15d', '20d']

# Average of Alisa LD and CH values
avg_c0 = [116.2, 113.2, 111.8, 114.5]
avg_c90 = [65.8, 68.9, 73.65, 83.55]
avg_t0 = [131, 162.85, 163.15, 152.4]
avg_t90 = [58.55, 83.15, 99.5, 97.25]

# My values
y_t0 = []
y_t90 = []
y_c0 = []
y_c90 = []

# Read all .csv files in directory 
for i in range(4):
    length = (i+1)*110
    angle = 0
    c = open(p2+'\\C.'+str(angle)+'.'+str(length)+'.csv', 'r')
    reader = csv.reader(c)
    for line in reader:
        x1 = ((round(float(line[0]),2)))
        x2 = ((round(float(line[1]),2)))
        y_c0.append(0.5*(x1+x2))
    angle = 9
    c = open(p2+'\\C.'+str(angle)+'.'+str(length)+'.csv', 'r')
    reader = csv.reader(c)
    for line in reader:
        x1 = ((round(float(line[0]),2)))
        x2 = ((round(float(line[1]),2)))
        y_c90.append(0.5*(x1+x2))
    angle = 0
    c = open(p2+'\\T.'+str(angle)+'.'+str(length)+'.csv', 'r')
    reader = csv.reader(c)
    for line in reader:
        x1 = ((round(float(line[0]),2)))
        x2 = ((round(float(line[1]),2)))
        y_t0.append(0.5*(x1+x2))
    angle = 9
    c = open(p2+'\\T.'+str(angle)+'.'+str(length)+'.csv', 'r')
    reader = csv.reader(c)
    for line in reader:
        x1 = ((round(float(line[0]),2)))
        x2 = ((round(float(line[1]),2)))
        y_t90.append(0.5*(x1+x2))

t0_full = []
t90_full = []
c0_full = []
c90_full = []
t0_red = []
t90_red = []
c0_red = []
c90_red = []

for i in range(len(y_t0)):
    if i%2==0:
        t0_full.append(y_t0[i])
        t90_full.append(y_t90[i])
        c0_full.append(y_c0[i])
        c90_full.append(y_c90[i])
    else:
        t0_red.append(y_t0[i])
        t90_red.append(y_t90[i])
        c0_red.append(y_c0[i])
        c90_red.append(y_c90[i])

# The "big 4" comparison plot
plt.rc('font', size=12)
plt.rc('legend', fontsize=12)    # legend fontsize

fig, axs = plt.subplots(2, 2, figsize=(10, 6), sharex=True, sharey=True)

axs[0,0].plot(x, t0_full, 'tab:blue', label="Full")
axs[0,0].plot(x, t0_red, 'tab:red', label="Reduced")
axs[0,0].plot(x, avg_t0, 'tab:gray', linestyle="dashdot", label=r"$K_{avg,exp}$")
axs[0,0].set_title("(a) "+r'$Tension, \alpha=0^o$')
axs[1,0].plot(x, t90_full, 'tab:blue', label="Full")
axs[1,0].plot(x, t90_red, 'tab:red', label="Reduced")
axs[1,0].plot(x, avg_t90, 'tab:gray', linestyle="dashdot", label=r"$K_{avg,exp}$")
axs[1,0].set_title("(c) "+r'$Tension, \alpha=90^o$')
axs[0,1].plot(x, c0_full, 'tab:blue', label="Full")
axs[0,1].plot(x, c0_red, 'tab:red', label="Reduced")
axs[0,1].plot(x, avg_c0, 'tab:gray', linestyle="dashdot", label=r"$K_{avg,exp}$")
axs[0,1].set_title("(b) "+r'$Compression, \alpha=0^o$')
axs[1,1].plot(x, c90_full, 'tab:blue', label="Full")
axs[1,1].plot(x, c90_red, 'tab:red', label="Reduced")
axs[1,1].plot(x, avg_c90, 'tab:gray', linestyle="dashdot", label=r"$K_{avg,exp}$")
axs[1,1].set_title("(d) "+r'$Compression, \alpha=90^o$')

for ax in axs.flat:
        ax.set(xlabel="Embedded length [mm]", ylabel="Stiffness [kN/mm]")
        ax.label_outer()
        ax.legend()

plt.savefig(p2+"\\meshComparison.png")

d = open(p2 + "\\Summary" +  '.csv', 'w', newline='')
writer = csv.writer(d)
writer.writerow(["$K_{full}$ [kN/mm]", "$K_{reduced}$ [kN/mm]", "Difference %"])

for i in range(len(t0_full)):
    x1 = round(t0_full[i], 2)
    x2 = round(t0_red[i], 2)
    e = round(100*(x1-x2)/x1, 1)
    writer.writerow([x1, x2, str(e)+"%"])
for i in range(len(t90_full)):
    x1 = round(t90_full[i], 2)
    x2 = round(t90_red[i], 2)
    e = round(100*(x1-x2)/x1, 1)
    writer.writerow([x1, x2, str(e)+"%"])
for i in range(len(c0_full)):
    x1 = round(c0_full[i], 2)
    x2 = round(c0_red[i], 2)
    e = round(100*(x1-x2)/x1, 1)
    writer.writerow([x1, x2, str(e)+"%"])
for i in range(len(c90_full)):
    x1 = round(c90_full[i], 2)
    x2 = round(c90_red[i], 2)
    e = round(100*(x1-x2)/x1, 1)
    writer.writerow([x1, x2, str(e)+"%"]) 