import matplotlib as mpl
import matplotlib.pyplot as plt
import numpy as np
import csv
import os
import sys

p2 = r"C:\Users\Johannes\Documents\Masteroppgave\Calibration\Mesh"

# Average of Alisa LD and CH values
avg_c0 = [116.2, 113.2, 111.8, 114.5]
avg_c90 = [65.8, 68.9, 73.65, 83.55]
avg_t0 = [131, 162.85, 163.15, 152.4]
avg_t90 = [58.55, 83.15, 99.5, 97.25]

# X axis
x = ['5d', '10d', '15d', '20d']

# My values
y_t0 = []
y_t90 = []
y_c0 = []
y_c90 = []

# Read all .csv files in directory 
for i in range(4):
    length = (i+1)*110
    angle = 0
    c = open(p2+'\\C.'+str(angle)+'.'+str(length)+'.csv', 'r')
    reader = csv.reader(c)
    for line in reader:
        x1 = ((round(float(line[0]),2)))
        x2 = ((round(float(line[1]),2)))
        y_c0.append(0.5*(x1+x2))
    angle = 9
    c = open(p2+'\\C.'+str(angle)+'.'+str(length)+'.csv', 'r')
    reader = csv.reader(c)
    for line in reader:
        x1 = ((round(float(line[0]),2)))
        x2 = ((round(float(line[1]),2)))
        y_c90.append(0.5*(x1+x2))
    angle = 0
    c = open(p2+'\\T.'+str(angle)+'.'+str(length)+'.csv', 'r')
    reader = csv.reader(c)
    for line in reader:
        x1 = ((round(float(line[0]),2)))
        x2 = ((round(float(line[1]),2)))
        y_t0.append(0.5*(x1+x2))
    angle = 9
    c = open(p2+'\\T.'+str(angle)+'.'+str(length)+'.csv', 'r')
    reader = csv.reader(c)
    for line in reader:
        x1 = ((round(float(line[0]),2)))
        x2 = ((round(float(line[1]),2)))
        y_t90.append(0.5*(x1+x2))

# Split them into 4 (emb. lengths)
y_t0 = np.array_split(y_t0, 4)
y_t90 = np.array_split(y_t90, 4)
y_c0 = np.array_split(y_c0, 4)
y_c90 = np.array_split(y_c90, 4)

# The "big 4" comparison plot
plt.rc('font', size=14)
plt.rc('legend', fontsize=12)    # legend fontsize

fig, axs = plt.subplots(2, 2, figsize=(10, 6), sharex=True, sharey=True)

axs[0,0].plot(x, y_t0)
axs[0,0].plot(x, avg_t0, 'tab:gray', linestyle="dashdot", label=r"$K_{avg,exp}$")
axs[0,0].set_title("(a) "+r'$Tension, \alpha=0^o$')
axs[1,0].plot(x, y_t90)
axs[1,0].plot(x, avg_t90, 'tab:gray', linestyle="dashdot", label=r"$K_{avg,exp}$")
axs[1,0].set_title("(c) "+r'$Tension, \alpha=90^o$')
axs[0,1].plot(x, y_c0)
axs[0,1].plot(x, avg_c0, 'tab:gray', linestyle="dashdot", label=r"$K_{avg,exp}$")
axs[0,1].set_title("(b) "+r'$Compression, \alpha=0^o$')
axs[1,1].plot(x, y_c90)
axs[1,1].plot(x, avg_c90, 'tab:gray', linestyle="dashdot", label=r"$K_{avg,exp}$")
axs[1,1].set_title("(d) "+r'$Compression, \alpha=90^o$')



for ax in axs.flat:
        ax.set(xlabel="Embedded length [mm]", ylabel="Stiffness [kN/mm]")
        ax.label_outer()
        ax.legend()

plt.savefig(p2+"\\varyKandG.png")


figs, ax2 = plt.subplots(1, figsize=(10,6), sharey=True)
plt.rc('font', size=14)
plt.rc('legend', fontsize=12)
shear = np.linspace(5, 100, 20)
ax2.set_title(r'$Tension, \alpha=0^o$')
ax2.plot(shear, y_t0[0], label="5d")
ax2.plot(shear, y_t0[1], label="10d")
ax2.plot(shear, y_t0[2], label="15d")
ax2.plot(shear, y_t0[3], label="20d")
ax2.set(xlabel=r"Cohesive stiffness $[N/mm^2]$", ylabel="Stiffness [kN/mm]")
ax2.legend()
plt.savefig(p2+"\\growthKandG.png")